library XT_Demo2;

uses Windows, XT_API;

var
	MainWnd: HWnd;

function XT_Init(nVersion, nFlags: DWord; hMainWnd: HWnd; lpReserved: Pointer): LongInt; stdcall; export;
begin
	if Assigned(XWF_OutputMessage) then begin
		Result:=1;
		MainWnd:=hMainWnd;
	end else
		Result:=-1;
end;

function XT_About(hTopWnd: HWnd; lpReserved: Pointer): LongInt; stdcall; export;
begin
	MessageBox(hTopWnd, 'This sample X-Tension says Hello when executed and otherwise does nothing.', 'Demo', MB_ICONINFORMATION);
end;

function XT_Prepare(hVolume, hEvidence: THandle; nOpType: DWord; lpReserved: Pointer): LongInt; stdcall; export;
begin
	if nOpType=XT_ACTION_RUN then MessageBox(MainWnd, 'Run directly from main menu', 'Hello', MB_ICONINFORMATION);
	if nOpType=XT_ACTION_RVS then MessageBox(MainWnd, 'Refine volume snapshot has started', 'Hello', MB_ICONINFORMATION);
	if nOpType=XT_ACTION_LSS then MessageBox(MainWnd, 'Logical search has started', 'Hello', MB_ICONINFORMATION);
	if nOpType=XT_ACTION_PSS then MessageBox(MainWnd, 'Physical search has started', 'Hello', MB_ICONINFORMATION);
	if nOpType=XT_ACTION_DBC then MessageBox(MainWnd, 'Run from directory browser context menu', 'Hello', MB_ICONINFORMATION);
	if nOpType=XT_ACTION_SHC then MessageBox(MainWnd, 'Run from search hit list context menu', 'Hello', MB_ICONINFORMATION);

	Result:=$0;
end;

function XT_ProcessItem(nItemID: LongInt; lpReserved: Pointer): LongInt; stdcall; export;
var
	DeletionStatus: DWord;
	FSize: Int64;
	nParentItemID: LongInt;
	Success: BOOL;
	hItem: THandle;
	Buf: array[0..20] of WideChar;
	Text: array[0..63] of AnsiChar;
begin
	XWF_OutputMessage('Called for', $2);
	XWF_OutputMessage(XWF_GetItemName(nItemID), $1 or $2);
end;

function XT_Finalize(hVolume, hEvidence: THandle; nOpType: DWord; lpReserved: Pointer): LongInt; stdcall; export;
begin
	MessageBox(MainWnd, 'Finished already!', 'That''s it', MB_ICONINFORMATION);

  Result:=0;
end;


exports
	XT_Init,
	XT_About,
	XT_Prepare,
	XT_ProcessItem,
	XT_Finalize;

begin
	{Here you could insert code that gets executed when the DLL is loaded.}

end.
